VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5310
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3735
   LinkTopic       =   "Form1"
   ScaleHeight     =   5310
   ScaleWidth      =   3735
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtResults 
      Height          =   2895
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   600
      Width           =   2775
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   2160
      TabIndex        =   2
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox txtNumTeams 
      Height          =   285
      Left            =   1200
      TabIndex        =   1
      Text            =   "5"
      Top             =   120
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "# Teams"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Return an array where results(i, j) gives the opponent of team i in round j.
' Note: num_teams must be odd.
Private Function GenerateRoundRobinOdd(ByVal num_teams As Integer) As Integer()
Dim n2 As Integer
Dim mid As Integer
Dim results() As Integer
Dim teams() As Integer
Dim i As Integer
Dim round As Integer
Dim team1 As Integer
Dim team2 As Integer

    n2 = num_teams \ 2
    mid = n2 + 1
    ReDim results(1 To num_teams, 1 To num_teams)

    ' Initialize the list of teams.
    ReDim teams(1 To num_teams)
    For i = 1 To num_teams
        teams(i) = i
    Next i

    ' Start the rounds.
    For round = 1 To num_teams
        For i = 0 To n2 - 1
            team1 = teams(mid - i)
            team2 = teams(mid + i + 1)
            results(team1, round) = team2
            results(team2, round) = team1
        Next i

        ' Set the team with the bye.
        team1 = teams(1)
        results(team1, round) = 0

        ' Rotate the array.
        RotateArray teams
    Next round

    GenerateRoundRobinOdd = results
End Function
' Return an array where results(i, j) gives the opponent of team i in round j.
' Note: num_teams must be even.
Private Function GenerateRoundRobinEven(ByVal num_teams As Integer) As Integer()
Dim results() As Integer
Dim results2() As Integer
Dim round As Integer
Dim team As Integer

    ' Generate the result for one fewer teams.
    results = GenerateRoundRobinOdd(num_teams - 1)

    ' Copy the results into a bigger array,
    ' replacing the byes with the extra team.
    ReDim results2(1 To num_teams, 1 To num_teams - 1)
    For team = 1 To num_teams - 1
        For round = 1 To num_teams - 1
            If results(team, round) = 0 Then
                ' Change the bye to the new team.
                results2(team, round) = num_teams
                results2(num_teams, round) = team
            Else
                results2(team, round) = results(team, round)
            End If
        Next round
    Next team

    GenerateRoundRobinEven = results2
End Function
' See: http://mathforum.org/library/drmath/sets/select/dm_scheduling.html
'
' Return an array where results(i, j) gives the opponent of team i in round j.
Private Function GenerateRoundRobin(ByVal num_teams As Integer) As Integer()
    If num_teams Mod 2 = 0 Then
        GenerateRoundRobin = GenerateRoundRobinEven(num_teams)
    Else
        GenerateRoundRobin = GenerateRoundRobinOdd(num_teams)
    End If
End Function


' Rotate the entries one position.
Private Sub RotateArray(teams() As Integer)
Dim tmp As Integer
Dim i As Integer

    tmp = teams(UBound(teams))
    For i = UBound(teams) To 2 Step -1
        teams(i) = teams(i - 1)
    Next i
    teams(1) = tmp
End Sub

Private Sub cmdGo_Click()
Dim num_teams As Integer
Dim num_rounds As Integer
Dim results() As Integer
Dim team As Integer
Dim round As Integer
Dim txt As String

    ' Get the schedule.
    num_teams = CInt(txtNumTeams.Text)
    results = GenerateRoundRobin(num_teams)

    ' Display the result.
    For round = 1 To UBound(results, 2)
        txt = txt & "Round " & round & ":" & vbCrLf
        For team = 1 To num_teams
            If results(team, round) = 0 Then
                txt = txt & "    " & team & " (bye)" & vbCrLf
            ElseIf team < results(team, round) Then
                txt = txt & "    " & team & " v " & results(team, round) & vbCrLf
            End If
        Next team
    Next round

    txtResults.Text = txt
End Sub
Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - txtResults.Top
    If hgt < 120 Then hgt = 120
    txtResults.Move 0, txtResults.Top, ScaleWidth, hgt
End Sub


